/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.32 Revision 1.68
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.32 2006/09/10 10:29:21 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.68 2009/03/06 09:09:29 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
38# 38#
39# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
41# 41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44# 44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
48 48
58# all patches which ending on diff or patch in this DIR will automatically applied 58# all patches which ending on diff or patch in this DIR will automatically applied
59# 59#
60 60
61inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62 62
63IUSE="debug" 63IUSE=""
64 64
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
67VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77
78DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
78 82
79 83# New method of storing plugindb
80# this code is from linux-mod.eclass 84# Called from src_install
81update_vdrplugindb() { 85# file maintained by normal portage-methods
86create_plugindb_file() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 87 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
83 88 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102
103vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC
106 use debug && append-flags -g
107
108 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111
112 # transition to /usr/share/... will need new vdr-scripts version stable
113 VDR_RC_DIR="/usr/lib/vdr/rcscript"
114
115 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include"
118
119
120 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
121 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
122 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
123
124 einfo "Building ${PF} against vdr-${VDRVERSION}"
125 einfo "APIVERSION: ${APIVERSION}"
126}
127
128vdr-plugin_src_unpack() {
129 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
130 eerror "Wrong use of vdr-plugin.eclass."
131 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
132 echo
133 eerror "Please report this at bugs.gentoo.org."
134 die "vdr-plugin_pkg_setup not called!"
135 fi
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
137
138 while [ "$1" ]; do
139
140 case "$1" in
141 unpack)
142 base_src_unpack
143 ;;
144 patchmakefile)
145 if ! cd ${S}; then
146 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
147 ewarn "Perhaps you find one among these:"
148 cd "${WORKDIR}"
149 einfo "$(/bin/ls -1 ${WORKDIR})"
150 die "Could not change to plugin-source-directory!"
151 fi
152
153 einfo "Patching Makefile"
154 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
155 cp Makefile Makefile.orig
156
157 sed -i Makefile \
158 -e '1i\#Makefile was patched by vdr-plugin.eclass'
159
160 ebegin " Setting Pathes"
161 sed -i Makefile \
162 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
163 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
164 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
165 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
166 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
167 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
168 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
169 eend $?
170
171 ebegin " Converting to APIVERSION"
172 sed -i Makefile \
173 -e 's:^APIVERSION = :APIVERSION ?= :' \
174 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
175 -e '2i\APIVERSION = '"${APIVERSION}"
176 eend $?
177
178 ebegin " Correcting CXXFLAGS"
179 sed -i Makefile \
180 -e 's:^CXXFLAGS:#CXXFLAGS:'
181 eend $?
182
183 ebegin " Disabling file stripping"
184 sed -i Makefile \
185 -e '/@.*strip/d' \
186 -e '/strip \$(LIBDIR)\/\$@/d' \
187 -e '/^STRIP =/d' \
188 -e '/@.*\$(STRIP)/d'
189 eend $?
190 PLUGIN_MAKEFILE_PATCHED=1
191 ;;
192 add_local_patch)
193 cd ${S}
194 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
195 echo
196 einfo "Applying local patches"
197 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
198 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
199 done
200 fi
201 ;;
202 esac
203
204 shift
205 done
206}
207
208vdr-plugin_copy_source_tree() {
209 pushd . >/dev/null
210 cp -r ${S} ${T}/source-tree
211 cd ${T}/source-tree
212 mv Makefile.orig Makefile
213 sed -i Makefile \
214 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
215 -e 's:^CXXFLAGS:#CXXFLAGS:' \
216 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
217 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
218 popd >/dev/null
219}
220
221vdr-plugin_install_source_tree() {
222 einfo "Installing sources"
223 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
224 insinto ${destdir}-${PV}
225 doins -r ${T}/source-tree/*
226
227 dosym ${VDRPLUGIN}-${PV} ${destdir}
228}
229
230vdr-plugin_src_compile() {
231 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
232
233 while [ "$1" ]; do
234
235 case "$1" in
236 prepare)
237 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
238 ;;
239 compile)
240 if [[ -z ${PLUGIN_MAKEFILE_PATCHED} ]]; then
241 eerror "Wrong use of vdr-plugin.eclass."
242 eerror "An ebuild for a vdr-plugin will not work without"
243 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
244 echo
245 eerror "Please report this at bugs.gentoo.org."
246 die "vdr-plugin_src_unpack not called!"
247 fi
248 cd ${S}
249
250 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
251 ;;
252 esac
253
254 shift
255 done
256}
257
258vdr-plugin_src_install() {
259 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
260 cd ${S}
261
262 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
263 local mname=${P}-Makefile
264 cp Makefile ${mname}.patched
265 cp Makefile.orig ${mname}.before
266
267 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
268
269 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
270 doins ${mname}.diff
271
272 insinto "/usr/share/vdr/maintainer-data/makefile-before"
273 doins ${mname}.before
274
275 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
276 doins ${mname}.patched
277
278 fi
279
280 insinto "${VDR_PLUGIN_DIR}" 89 insinto "${NEW_VDRPLUGINDB_DIR}"
281 doins libvdr-*.so.*
282 local docfile
283 for docfile in README* HISTORY CHANGELOG; do
284 [[ -f ${docfile} ]] && dodoc ${docfile}
285 done
286 90
287 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 91# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
288 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 92# cat <<-EOT > "${D}/${DB_FILE}"
93# VDRPLUGIN_DB=1
94# CREATOR=ECLASS
95# EBUILD=${CATEGORY}/${PN}
96# EBUILD_V=${PVR}
97# EOT
98 {
99 echo "VDRPLUGIN_DB=1"
100 echo "CREATOR=ECLASS"
101 echo "EBUILD=${CATEGORY}/${PN}"
102 echo "EBUILD_V=${PVR}"
103 echo "PLUGINS=\"$@\""
104 } > "${D}/${DB_FILE}"
105}
289 106
290 if [[ -n ${VDR_CONFD_FILE} ]]; then 107# Delete files created outside of vdr-plugin.eclass
291 insinto /etc/conf.d 108# vdrplugin-rebuild.ebuild converted plugindb and files are
292 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 109# not deleted by portage itself - should only be needed as
293 fi 110# long as not every system has switched over to
111# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
112delete_orphan_plugindb_file() {
113 #elog Testing for orphaned plugindb file
114 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
115 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
294 116
117 # file exists
118 [[ -f ${DB_FILE} ]] || return
295 119
296 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 120 # will portage handle the file itself
297 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 121 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
298 122 #elog file owned by eclass - don't touch it
299 if [[ -n ${VDR_RCADDON_FILE} ]]; then 123 return
300 insinto "${VDR_RC_DIR}"
301 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
302 fi 124 fi
303 125
126 elog "Removing orphaned plugindb-file."
127 elog "\t#rm ${DB_FILE}"
128 rm "${DB_FILE}"
129}
304 130
305 131
306 insinto ${VDR_CHECKSUM_DIR} 132create_header_checksum_file()
133{
134 # Danger: Not using $ROOT here, as compile will also not use it !!!
135 # If vdr in $ROOT and / differ, plugins will not run anyway
136
137 local CHKSUM="header-md5-vdr"
138
307 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 139 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
308 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 140 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
141 elif type -p md5sum >/dev/null 2>&1; then
142 (
143 cd "${VDR_INCLUDE_DIR}"
144 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
145 ) > "${CHKSUM}"
309 else 146 else
310 if which md5sum >/dev/null 2>&1; then 147 die "Could not create md5 checksum of headers"
311 cd ${S}
312 (
313 cd ${ROOT}${VDR_INCLUDE_DIR}
314 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
315 ) > header-md5-${PN}
316 doins header-md5-${PN}
317 fi 148 fi
318 fi
319}
320 149
321vdr-plugin_pkg_postinst() { 150 insinto "${VDR_CHECKSUM_DIR}"
322 update_vdrplugindb 151 local p_name
323 einfo 152 for p_name; do
324 einfo "The vdr plugin ${VDRPLUGIN} has now been installed." 153 newins "${CHKSUM}" "header-md5-${p_name}"
325 einfo "To activate execute the following command:"
326 einfo
327 einfo " emerge --config ${PN}"
328 einfo
329 if [[ -n "${VDR_CONFD_FILE}" ]]; then
330 einfo "And have a look at the config-file"
331 einfo "/etc/conf.d/vdr.${VDRPLUGIN}"
332 einfo
333 fi
334}
335
336vdr-plugin_pkg_postrm() {
337 remove_vdrplugindb
338}
339
340vdr-plugin_pkg_config_final() {
341 diff ${conf_orig} ${conf}
342 rm ${conf_orig}
343}
344
345vdr-plugin_pkg_config() {
346 if [[ -z "${INSTALLPLUGIN}" ]]; then
347 INSTALLPLUGIN="${VDRPLUGIN}"
348 fi
349 # First test if plugin is already inside PLUGINS
350 local conf=/etc/conf.d/vdr
351 conf_orig=${conf}.before_emerge_config
352 cp ${conf} ${conf_orig}
353
354 einfo "Reading ${conf}"
355 if ! grep -q "^PLUGINS=" ${conf}; then
356 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
357 if [[ -n "${LINE}" ]]; then
358 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
359 else
360 echo 'PLUGINS=""' >> ${conf}
361 fi
362 unset LINE
363 fi
364
365 unset PLUGINS
366 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
367
368 active=0
369 for p in ${PLUGINS}; do
370 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
371 active=1
372 break;
373 fi
374 done 154 done
375
376 if [[ "${active}" == "1" ]]; then
377 einfo "${INSTALLPLUGIN} already activated"
378 echo
379 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
380 if [[ "${answer}" != "yes" ]]; then
381 einfo "aborted"
382 return
383 fi
384 einfo "Removing ${INSTALLPLUGIN} from active plugins."
385 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
386 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
387 -e ${LINE}'s/ \( \)*/ /g' \
388 -e ${LINE}'s/ "/"/g' \
389 -e ${LINE}'s/" /"/g'
390
391 vdr-plugin_pkg_config_final
392 return
393 fi
394
395
396 einfo "Adding ${INSTALLPLUGIN} to active plugins."
397 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
398 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
399 -e ${LINE}'s/ \( \)*/ /g' \
400 -e ${LINE}'s/ "/"/g' \
401 -e ${LINE}'s/" /"/g'
402
403 vdr-plugin_pkg_config_final
404} 155}
405 156
406fix_vdr_libsi_include() 157fix_vdr_libsi_include()
407{ 158{
408 einfo "Fixing include of libsi-headers" 159 einfo "Fixing include of libsi-headers"
412 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
413 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
414 done 165 done
415} 166}
416 167
168vdr_patchmakefile() {
169 einfo "Patching Makefile"
170 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
171 cp Makefile "${WORKDIR}"/Makefile.before
172
173 # plugin makefiles use VDRDIR in strange ways
174 # assumptions:
175 # 1. $(VDRDIR) contains Make.config
176 # 2. $(VDRDIR) contains config.h
177 # 3. $(VDRDIR)/include/vdr contains the headers
178 # 4. $(VDRDIR) contains main vdr Makefile
179 # 5. $(VDRDIR)/locale exists
180 # 6. $(VDRDIR) allows to access vdr source files
181 #
182 # We only have one directory (for now /usr/include/vdr),
183 # that contains vdr-headers and Make.config.
184 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR)
188
189 ebegin " Setting paths"
190 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \
195 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::'
197 eend 0
198
199 # maybe needed for multiproto:
200 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
203
204 if ! grep -q APIVERSION Makefile; then
205 ebegin " Converting to APIVERSION"
206 sed -i Makefile \
207 -e 's:^APIVERSION = :APIVERSION ?= :' \
208 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
209 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
210 eend $?
211 fi
212
213 # Correcting Compile-Flags
214 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
215 sed -i Makefile \
216 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
217 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
218
219 # Disabling file stripping, useful for debugging
220 sed -i Makefile \
221 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d'
224
225 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228}
229
230vdr_add_local_patch() {
231 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
232 echo
233 einfo "Applying local patches"
234 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
235 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
236 done
237 fi
238}
239
240vdr_has_gettext() {
241 has_version ">=media-video/vdr-1.5.7"
242}
243
244plugin_has_gettext() {
245 [[ -d po ]]
246}
247
248vdr_i18n_convert_to_gettext() {
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
250
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild"
253 return 1
254 fi
255
256 if [[ ! -x ${i18n_tool} ]]; then
257 eerror "Missing ${i18n_tool}"
258 eerror "Please re-emerge vdr"
259 die "Missing ${i18n_tool}"
260 fi
261
262 ebegin "Auto converting translations to gettext"
263 # call i18n-to-gettext tool
264 # take all texts missing tr call into special file
265 "${i18n_tool}" 2>/dev/null \
266 |sed -e '/^"/!d' \
267 -e '/^""$/d' \
268 -e 's/\(.*\)/trNOOP(\1)/' \
269 > dummy-translations-trNOOP.c
270
271 # if there were untranslated texts just run it again
272 # now the missing calls are listed in
273 # dummy-translations-trNOOP.c
274 if [[ -s dummy-translations-trNOOP.c ]]; then
275 "${i18n_tool}" &>/dev/null
276 fi
277
278 # now use the modified Makefile
279 if [[ -f Makefile.new ]]; then
280 mv Makefile.new Makefile
281 eend 0 ""
282 else
283 eend 1 "Conversion to gettext failed. Plugin needs fixing."
284 return 1
285 fi
286}
287
288vdr_i18n_disable_gettext() {
289 ebegin "Disabling gettext support in plugin"
290 # Remove i18n Target if using older vdr
291 sed -i Makefile \
292 -e '/^all:/s/ i18n//'
293 eend 0
294}
295
296vdr_i18n() {
297 if vdr_has_gettext; then
298 einfo "VDR has gettext support"
299 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK."
303 fi
304 else
305 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then
307 eerror ""
308 eerror "Plugin will have only english OSD texts"
309 eerror "it needs manual fixing."
310 fi
311 fi
312 else
313 einfo "VDR has no gettext support"
314 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext
316 fi
317 fi
318}
319
320vdr-plugin_copy_source_tree() {
321 pushd . >/dev/null
322 cp -r "${S}" "${T}"/source-tree
323 cd "${T}"/source-tree
324 cp "${WORKDIR}"/Makefile.before Makefile
325 # TODO: Fix this, maybe no longer needed
326 sed -i Makefile \
327 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
328 -e 's:^CXXFLAGS:#CXXFLAGS:' \
329 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
330 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
331 popd >/dev/null
332}
333
334vdr-plugin_install_source_tree() {
335 einfo "Installing sources"
336 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
337 insinto "${destdir}-${PV}"
338 doins -r "${T}"/source-tree/*
339
340 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
341}
342
343vdr-plugin_print_enable_command() {
344 local p_name c=0 l=""
345 for p_name in ${vdr_plugin_list}; do
346 c=$(( c+1 ))
347 l="$l ${p_name#vdr-}"
348 done
349
350 elog
351 case $c in
352 1) elog "Installed plugin${l}" ;;
353 *) elog "Installed $c plugins:${l}" ;;
354 esac
355 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog
358}
359
360
361## exported functions
362
363vdr-plugin_pkg_setup() {
364 # -fPIC is needed for shared objects on some platforms (amd64 and others)
365 append-flags -fPIC
366
367 # Where should the plugins live in the filesystem
368 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
369 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
370
371 # was /usr/lib/... some time ago
372 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
373 VDR_RC_DIR="/usr/share/vdr/rcscript"
374
375 # Pathes to includes
376 VDR_INCLUDE_DIR="/usr/include/vdr"
377 DVB_INCLUDE_DIR="/usr/include"
378
379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
380 LOCDIR="/usr/share/vdr/locale"
381
382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
385
386 einfo "Compiling against"
387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
388}
389
390vdr-plugin_src_util() {
391
392 while [ "$1" ]; do
393
394 case "$1" in
395 all)
396 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
397 ;;
398 prepare|all_but_unpack)
399 vdr-plugin_src_util add_local_patch patchmakefile i18n
400 ;;
401 unpack)
402 base_src_unpack
403 ;;
404 add_local_patch)
405 cd "${S}" || die "Could not change to plugin-source-directory!"
406 vdr_add_local_patch
407 ;;
408 patchmakefile)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_patchmakefile
411 ;;
412 i18n)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_i18n
415 ;;
416 esac
417
418 shift
419 done
420}
421
422vdr-plugin_src_unpack() {
423 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
424 eerror "Wrong use of vdr-plugin.eclass."
425 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
426 echo
427 eerror "Please report this at bugs.gentoo.org."
428 die "vdr-plugin_pkg_setup not called!"
429 fi
430 if [ -z "$1" ]; then
431 case "${EAPI:-0}" in
432 2)
433 vdr-plugin_src_util unpack
434 ;;
435 *)
436 vdr-plugin_src_util all
437 ;;
438 esac
439
440 else
441 vdr-plugin_src_util $@
442 fi
443}
444
445vdr-plugin_src_prepare() {
446 base_src_prepare
447 vdr-plugin_src_util prepare
448}
449
450vdr-plugin_src_compile() {
451 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
452
453 while [ "$1" ]; do
454
455 case "$1" in
456 copy_source)
457 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
458 ;;
459 compile)
460 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
461 eerror "Wrong use of vdr-plugin.eclass."
462 eerror "An ebuild for a vdr-plugin will not work without"
463 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
464 echo
465 eerror "Please report this at bugs.gentoo.org."
466 die "vdr-plugin_src_unpack not called!"
467 fi
468 cd "${S}"
469
470 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
471
472 emake ${BUILD_PARAMS} \
473 ${BUILD_TARGETS} \
474 LOCALEDIR="${TMP_LOCALE_DIR}" \
475 LIBDIR="${S}" \
476 TMPDIR="${T}" \
477 || die "emake failed"
478 ;;
479 esac
480
481 shift
482 done
483}
484
485vdr-plugin_src_install() {
486 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
487 cd "${WORKDIR}"
488
489 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
490 local mname="${P}-Makefile"
491 cp "${S}"/Makefile "${mname}.patched"
492 cp Makefile.before "${mname}.before"
493
494 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
495
496 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
497 doins "${mname}.diff"
498
499 insinto "/usr/share/vdr/maintainer-data/makefile-before"
500 doins "${mname}.before"
501
502 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
503 doins "${mname}.patched"
504
505 fi
506
507
508
509 cd "${S}"
510 insinto "${VDR_PLUGIN_DIR}"
511 doins libvdr-*.so.*
512
513 # create list of all created plugin libs
514 vdr_plugin_list=""
515 local p_name
516 for p in libvdr-*.so.*; do
517 p_name="${p%.so*}"
518 p_name="${p_name#lib}"
519 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
520 done
521
522 create_header_checksum_file ${vdr_plugin_list}
523 create_plugindb_file ${vdr_plugin_list}
524
525 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
526 einfo "Installing locales"
527 cd "${TMP_LOCALE_DIR}"
528 insinto "${LOCDIR}"
529 doins -r *
530 fi
531
532 cd "${S}"
533 local docfile
534 for docfile in README* HISTORY CHANGELOG; do
535 [[ -f ${docfile} ]] && dodoc ${docfile}
536 done
537
538 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
539 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
540
541 if [[ -n ${VDR_CONFD_FILE} ]]; then
542 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
543 fi
544
545
546 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
547 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
548
549 if [[ -n ${VDR_RCADDON_FILE} ]]; then
550 insinto "${VDR_RC_DIR}"
551 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
552 fi
553}
554
555vdr-plugin_pkg_postinst() {
556 vdr-plugin_print_enable_command
557
558 if [[ -n "${VDR_CONFD_FILE}" ]]; then
559 elog "Please have a look at the config-file"
560 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
561 elog
562 fi
563}
564
565vdr-plugin_pkg_postrm() {
566 delete_orphan_plugindb_file
567}
568
569vdr-plugin_pkg_config() {
570 ewarn "emerge --config ${PN} is no longer supported"
571 vdr-plugin_print_enable_command
572}
573
574case "${EAPI:-0}" in
575 2)
576 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
577 ;;
578 *)
417EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 579 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
580 ;;
581esac

Legend:
Removed from v.1.32  
changed lines
  Added in v.1.68

  ViewVC Help
Powered by ViewVC 1.1.20